;*** test.inc ***;
;------------------------------------------------
; Author: Torsten Knorr
;------------------------------------------------

 .ifndef __RFM12BP_TEST__
 .equ    __RFM12BP_TEST__ = 1

 .include "RFM12BP.inc"

;------------------------------------------------

 .macro M_RFM12BP_TEST_SIGNAL

 TEST_LOOP:

    sbi  PORTC,         RFM12BP_EN_TX

    M_SPI_MT_CMD (CMD_READ_STATUS)
    M_SPI_MT_CMD (CMD_SET_FREQ   | @0)
    M_SPI_MT_CMD (CMD_TX_CONFIG  | OUTPUT_POWER_MAX | FREQ_DEVIATION_30)
    M_SPI_MT_CMD (CMD_SET_POWER | EN_TX | EN_SYNTH | EN_CRYSTAL | DI_CLK_PIN)

    cbi  SPI_PORT,      SPI_SS

    M_SET_TIMER TIME_1S

 TEST_SIGNAL_LOOP:
    wdr

 TEST_SIGNAL_WAIT:
    sbis PIND,         RFM12BP_SDO
    rjmp TEST_SIGNAL_WAIT

    M_SPI_MT_WORD (CMD_TRANSMIT | @1)

    ;sbic STATUS_REG,    TIMER_RUN_BIT
    rjmp TEST_SIGNAL_LOOP

    sbi  SPI_PORT,      SPI_SS

    M_SPI_MT_CMD (CMD_SET_POWER | EN_SYNTH | EN_CRYSTAL | DI_CLK_PIN)
    M_SPI_MT_CMD (CMD_READ_STATUS)

    ;cbi  PORTC,         RFM12BP_EN_TX

    M_SET_TIMER 0xFFFF
    M_WAIT_TIMER

    rjmp TEST_LOOP

 .endmacro

;------------------------------------------------

 .macro M_RFM12BP_TEST_ANTENNA

    M_SPI_MT_CMD (CMD_TX_CONFIG  | OUTPUT_POWER_9 | FREQ_DEVIATION_30)
    M_SPI_MT_CMD (CMD_SET_POWER | EN_TX | EN_SYNTH | EN_CRYSTAL | DI_CLK_PIN)

    ldi  R_COUNT_L,     0x60
    ldi  R_COUNT_H,     0x00

    sbi  PORTC,         RFM12BP_EN_TX

 TEST_ANTENNA_LOOP:
    wdr

    ldi  R_TEMP_L,      0x3F
    ldi  R_TEMP_H,      0x0F
    cp   R_TEMP_L,      R_COUNT_L
    cpc  R_TEMP_H,      R_COUNT_H
    brsh NEXT_FREQUENCY

    ldi  R_COUNT_L,     0x60
    ldi  R_COUNT_H,     0x00

 NEXT_FREQUENCY:

    M_SPI_MT_CMD (CMD_READ_STATUS)
    movw R_TEMP_L,      R_COUNT_L
    ori  R_TEMP_H,      HIGH(CMD_SET_FREQ)
    M_SPI_TRANSFER

    M_SET_TIMER TIME_10MS
    M_WAIT_TIMER

    adiw R_COUNT_L,     1
    rjmp TEST_ANTENNA_LOOP

 .endmacro

;------------------------------------------------

 .macro TEST_TIMER_2

 TEST_TIMER_2_LOOP:
    wdr

    M_SET_TIMER_2 38
    M_WAIT_TIMER_2
    M_LED_DEBUG_2_ON

    M_SET_TIMER_2 38
    M_WAIT_TIMER_2
    M_LED_DEBUG_2_OFF

    rjmp TEST_TIMER_2_LOOP

 .endmacro

;------------------------------------------------

 .macro TEST_TIMEOUT_TIMER_2

 TEST_TIMEOUT_TIMER_2_LOOP:

    M_LED_DEBUG_1_ON
    M_NOP_80
    rcall Function_1

    M_SET_TIMER_1 TIME_1S
    M_WAIT_TIMER_1

    rcall Function_2

    M_LED_DEBUG_1_OFF
    M_NOP_80

    rjmp TEST_TIMEOUT_TIMER_2_LOOP

 Function_1:

    M_SET_TIMER_2 0x27
    ;M_SET_TIMER_2 0x26 ; timeout

    ret

 Function_2:

    M_CHECK_TIMER_2
    rjmp NO_TEST_ACTION

    M_LED_DEBUG_2_ON
    M_NOP_80
    M_LED_DEBUG_2_OFF

    NO_TEST_ACTION:

    M_STOP_TIMER_2

    ret

 .endmacro

;------------------------------------------------

 .macro M_NOP_10

    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop

 .endmacro

;------------------------------------------------

 .macro M_NOP_20

    M_NOP_10
    M_NOP_10

 .endmacro

;------------------------------------------------

 .macro M_NOP_40

    M_NOP_20
    M_NOP_20

 .endmacro

;------------------------------------------------

 .macro M_NOP_80

    M_NOP_40
    M_NOP_40

 .endmacro

;------------------------------------------------

 .endif

;------------------------------------------------
